#define TCRT_PIN A3
#define THRESHOLD 880
#define POWER_PIN 5

unsigned long sensorHighSince;
unsigned long sensorLowSince;

unsigned long sensorHasBeenLowMillis;
unsigned long sensorHasBeenHighMillis;


int previousPulseState;


//Power save
#include <JeeLib.h>                                                   // https://github.com/jcw/jeelib
#include <RF69_avr.h>
#define REG_SYNCVALUE1      0x2F
#include <avr/power.h>
#include <avr/sleep.h>
#include <OneWire.h>
#include <DallasTemperature.h>
ISR(WDT_vect) { Sleepy::watchdogEvent(); }          

void setup(){

  pinMode(TCRT_PIN, INPUT_PULLUP);

  pinMode(POWER_PIN, OUTPUT);
  //digitalWrite(POWER_PIN, HIGH);
  //With power low, reading 88-100
  
  previousPulseState = analogRead(TCRT_PIN) < THRESHOLD;
   
  Serial.begin(115200);

}

void loop(){

  unsigned long now = millis();
  
  pinMode(POWER_PIN, OUTPUT);
  digitalWrite(POWER_PIN, HIGH);




  int sensorValue = analogRead(TCRT_PIN);
  digitalWrite(POWER_PIN, LOW);
  pinMode(POWER_PIN, INPUT_PULLUP);

  int pulseState = sensorValue < THRESHOLD;

  if (pulseState != previousPulseState) {
    //Pulse change

    if (pulseState == 1) {
       sensorHasBeenLowMillis = now - sensorLowSince;
       sensorHighSince = now;

    } else {
      sensorHasBeenHighMillis = now - sensorHighSince;
      sensorLowSince = now;

    }
  } 

  previousPulseState = sensorValue;

  power_timer0_enable();

  Serial.print(pulseState);
  Serial.print(" (");
  Serial.print(sensorValue);
  Serial.print(") th=");
  Serial.print(sensorHasBeenHighMillis);
  Serial.print(" tl=");
  Serial.print(sensorHasBeenLowMillis);
  Serial.println();
  delay(100);
  power_timer0_disable();

     //Go to sleep
   Sleepy::loseSomeTime(100);
  

  
}



